<?php
class ControllerExtensionPaymentRukassa extends Controller
{
    public function index()
    {
        $data['button_confirm'] = $this->language->get('button_confirm');
		
        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $data['shop_id'] = $this->config->get('payment_rukassa_merchant_id');
        $data['amount'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false)*1;
        $data['currency'] = strtoupper($order_info['currency_code']);
		$data['order_id'] = $this->session->data['order_id'];
		$data['token'] = $this->config->get('payment_rukassa_secret_key_1');

        $this->model_checkout_order->addOrderHistory($data['order_id'], $this->config->get('payment_rukassa_order_wait_id'));

        $data = [
            'shop_id'	=> $data['shop_id'],
            'token'		=> $data['token'],
            'order_id' 	=> $data['order_id'],
            'amount' 	=> $data['amount'],
            'user_code' => $this->getIP(),
        ];


        $ch = curl_init('https://lk.rukassa.io/api/v1/create');
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data, '', '&'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_HEADER, false);
        $result = json_decode(curl_exec($ch));
        curl_close($ch);

        $data['action'] = $result->url;

		return $this->load->view('extension/payment/rukassa', $data);
    }

    public function status()
    {
		$token = $this->config->get('payment_rukassa_secret_key_1');

		$sign = $_SERVER['HTTP_SIGNATURE'];
		$sign2 = hash_hmac('sha256', $this->request->post['order_id'] . '|' . $this->request->post['createdDateTime'] . '|' . $this->request->post['amount'], $token);

        $this->load->model('checkout/order');
        $order = $this->model_checkout_order->getOrder($this->request->post['order_id']);

		if(empty($order)) {
			die("order_id not found");
		}

		if($_POST['amount'] < $order['total']) {
			die("wrong amount");
		}

		if($sign == $sign2) {
			
			if($order['order_status_id'] !== $this->config->get('payment_rukassa_order_success_id')) {
				$this->model_checkout_order->addOrderHistory($this->request->post['order_id'], $this->config->get('payment_rukassa_order_success_id'));
			} else {
				die("order has complete");
			}
			
			echo "OK";
		} else {
			echo 'ERROR SIGN';
		}
    }

    public function fail()
    {
        $this->response->redirect($this->url->link('checkout/checkout'));
        return true;
    }

    public function success()
    {
		$this->cart->clear();
        $this->response->redirect($this->url->link('checkout/success'));
        return true;
    }

    private function getIP() {
		$ip = $this->request->server['REMOTE_ADDR'];
		
		if(isset($this->request->server['HTTP_X_FORWARDED_FOR'])) {
			$ip = $this->request->server['HTTP_X_FORWARDED_FOR'];
		}
		
		if(isset($this->request->server['HTTP_X_REAL_IP'])) {
			$ip = $this->request->server['HTTP_X_REAL_IP'];
		}
		
		if(isset($this->request->server['HTTP_CF_CONNECTING_IP'])) {
			$ip = $this->request->server['HTTP_CF_CONNECTING_IP'];
		}

		$explode = explode(',', $ip);
		
		if(count($explode) > 1) {
			$ip = trim($explode[0]);
		}
		
		return $ip;
	}

}